 import java.net.*;
 import java.io.*;

 public class UDPserver{

	public static int PORT = 6697;
	public static Integer onlyLine = new Integer(1);
	public static boolean allLines = true;
	public static DatagramSocket socket;
	public static DatagramPacket packet;
	public static InetAddress address;

	public UDPserver(int newport, String udpAddress){

		if (newport > 0){
			PORT = newport;
		}
		
		try{
	        socket = new DatagramSocket(PORT);
		}catch(java.io.IOException e){
			System.err.println("Socket Error: " + e);
		}

		try{
			address = InetAddress.getByName(udpAddress);
		}catch(java.net.UnknownHostException e){	
			System.err.println("Uknown Host Exception: " + e);
		}
	}  // UDPserver

	public static void sendData(String str){
		str = str.replace((char)10, ' ');
		str = str.replace((char)13, ' ');

		byte[] data = null;
		data = str.getBytes();
		packet = new DatagramPacket(data,data.length,address,PORT);

		try{
			socket.send(packet);
		}catch(IOException e){
			System.err.println("IO Exception: " + e);
		}catch(NullPointerException npe){
			System.err.println("Null Pointer Exception!");
			System.err.println("\n" + packet.toString());
			System.err.println("Socket address: " + packet.getSocketAddress().toString());
			System.err.println("Data: ");
			byte[] pdata = packet.getData();
			System.err.println("Data: " + pdata.toString());
			System.err.println("Length: " + packet.getLength());
		}
	} // sendData
	
	public static void shutdown(){
		try{
			socket.close();
			socket = null;
		}catch(NullPointerException closeNPE){
				
		}
	} // shutdown

}  // class UDPserver

class UnicodeFormatter  {

   static public String byteToHex(byte b) {
      // Returns hex String representation of byte b
      char hexDigit[] = {
         '0', '1', '2', '3', '4', '5', '6', '7',
         '8', '9', 'a', 'b', 'c', 'd', 'e', 'f'
      };
      char[] array = { hexDigit[(b >> 4) & 0x0f], hexDigit[b & 0x0f] };
      return new String(array);
   }

   static public String charToHex(char c) {
      // Returns hex String representation of char c
      byte hi = (byte) (c >>> 8);
      byte lo = (byte) (c & 0xff);
      return byteToHex(hi) + byteToHex(lo);
   }

} // class UnicodeFormatter